package main

import (
  "fmt"
  "math"
  "math/rand"
  "os"
  "strconv"
)

type funz func(float64) float64

func integraMonteCarlo(f funz, a,b float64, A float64, n int) float64 {
  areaRett := A * (b - a)
  aSegno := 0
  for i := 0; i < n; i++ {
    y := A * rand.Float64()
    x := a + (b - a) * rand.Float64()
    if y < f(x) {
      aSegno++
    }
  }
  return areaRett * float64(aSegno) / float64(n)
}

func main() {
  var A float64
  var n int
  A, _ = strconv.ParseFloat(os.Args[1], 64)
  n, _ = strconv.Atoi(os.Args[2])
  fmt.Println(integraMonteCarlo(func (x float64) float64 {return x*x*x+x*math.Sin(x)/2}, 5, 9, A, n))

}
